#include "person.hpp"
#include "student.hpp"
#include "dozent.hpp"
#include "studierenderdozent.hpp"
#include <iostream>
#include <typeinfo>

int main() {
	double x = 3.5;
	std::cout << static_cast<int>(x) << std::endl;

	
	Student s1("Hans", "Müller", 31337);
	s1.setThesis(new Thesis("Eine Robotersteuerung für das Erkennen und Umfahren von Hindernissen"));
	
	Person& p = s1;
	
	
	Person* pptr = new Student("Fritz", "Schmidt", 105);
	Thesis* t = new Thesis("foo");
	
	//pptr->setThesis(t);
		
	Student* sptr = dynamic_cast<Student*>(pptr);
	if (sptr) {
		std::cout << "Ist ein Student" << std::endl;
		//sptr->setThesis(t);
	}
	
	
	Student& s = dynamic_cast<Student&>(p);
	//s.setThesis(t);
	
	
	const Student s3("Lisa", "Meyer", 12354);
	Student& s3ref = const_cast<Student&>(s3);
	s3ref.setThesis(t);
	//Person& p3ref = const_cast<Person&>(s3);
	
	
	Person* p4 = reinterpret_cast<Person*>(t);
	//std::cout << p4->toString() << std::endl;
	
	if( typeid(s1) == typeid(*pptr) ){
		std::cout << "s1 und *pptr haben gleiche Klasse " << std::endl;
	}
	
	std::cout << typeid(s1).name() << std::endl;
	
	std::cout << std::endl << std::endl;
	return 0;
}
